//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 PaleVioletRed
#property indicator_width1 2

//
//
//
//
//

extern int StdPeriod           = 14;
extern int StdPrice            = PRICE_CLOSE;
extern int NormalizationPeriod = 14;

double sto[];
double std[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(5);
   IndicatorBuffers(2);
      SetIndexBuffer(0,sto);
      SetIndexBuffer(1,std);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i=limit; i>=0; i--)
      {
         std[i] = iStdDev(NULL,0,StdPeriod,0,MODE_SMA,StdPrice,i);
            double min = std[ArrayMinimum(std,NormalizationPeriod,i)];
            double max = std[ArrayMaximum(std,NormalizationPeriod,i)];
            if (min!=max)
                  sto[i] = (std[i]-min)/(max-min);
            else  sto[i] = 0.5;             
      }               
      return(0);
}